=== debian/changelog ===
openturns (1.3-3) testing-proposed-updates; urgency=medium

  * debian/patches/modify-tests-O0-i386.patch: Drop patch, it is
    no more needed with recent GCC.  Closes: #769260

 -- Denis Barbier <barbier@debian.org>  Sun, 23 Nov 2014 11:38:35 +0000

openturns (1.3-2) unstable; urgency=medium

  * tests-disable-broken-R.patch: New patch, to disable 3
    tests which fail with latest R.  Closes: #743073

 -- Denis Barbier <barbier@debian.org>  Sat, 19 Apr 2014 21:40:58 +0200

openturns (1.3-1) unstable; urgency=medium

  [ Julien Schueller ]
  * New upstream release

 -- Denis Barbier <barbier@debian.org>  Thu, 06 Mar 2014 22:15:54 +0100

openturns (1.3~rc3-1) experimental; urgency=medium

  [ Julien Schueller ]
  * New upstream pre-release
  * Add build-dependency to libboost-math-dev

  [ Denis Barbier ]
  * Add a pretty-printer for OT types in gdb

 -- Denis Barbier <barbier@debian.org>  Fri, 21 Feb 2014 19:39:09 +0100

openturns (1.3~rc2-1) experimental; urgency=medium

  [ Julien Schueller ]
  * New upstream pre-release.
  * Upstream removes cdflib. Closes: #734855

  [ Denis Barbier ]
  * debian/copyright: Add missing stanzas.  Closes: #734856

 -- Denis Barbier <barbier@debian.org>  Tue, 21 Jan 2014 20:31:20 +0100

openturns (1.3~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.
  * Output test log on failure
  * Bump soname to 0.4
  * Build-depends on libmuparser-dev

  [ Denis Barbier ]
  * Update libopenturns0.4.lintian-overrides

 -- Denis Barbier <barbier@debian.org>  Wed, 08 Jan 2014 22:34:47 +0100
